Unit qs20e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, FTF1P_p, UTQS12_p;

procedure qs20e(var U :Array of Extended; var V :Array of Extended;
                A :Extended; B :Extended; F :Proc_F3_Q; N :Integer;
                var IERR :Integer);

implementation

procedure qs20e(var U :Array of Extended; var V :Array of Extended;
                A :Extended; B :Extended; F :Proc_F3_Q; N :Integer;
                var IERR :Integer);
var
IN_,K,KK :Integer;
D,D1,F1,F2,P,X :Extended;
const
NMAX :Integer = 1048576;
label
_10,_20,_30,_40;
begin
IERR  := 0;
if ( N  =  0 ) 
 then goto _40;
if ( N  <=  NMAX ) 
 then goto _10;
IERR  := 65;
UTQS12(IERR,16);
goto _40;
_10:
D  := B - A;
D1  := D/N;
IN_  := 1;
KK  := 1;
P  := 1.e0;
for K:=1 to N do
 begin
  X  := A + (K - 1)*D1;
  F(X,F1,F2);
  U[K-1] := F1;
  V[K-1] := F2;
_20:
 end;
FTF1P(U,V,N,IN_,KK,P);
for K:=1 to N do
 begin
  U[K-1] := D1*U[K-1];
  V[K-1] := D1*V[K-1];
_30:
 end;
_40:
end;

end.
